var lWarn = {logln:function (o){}};
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "event-checker.log";
lWarn = new Logger(LOGFILE_NAME);
//lInfo = new Logger(LOGFILE_NAME);

function addLeadingZeroes(number, count) {
    var result = '' + number;
    while (result.length < count) {
        result = '0' + result;
    }
    return result;
}

function checkCondition(pathToDescription)
{
	var delay=0;
	lInfo.logln('checking path ' + pathToDescription);
	if (Property.getNode(pathToDescription +'/delay')!=null)
		delay=Property.getNode(pathToDescription +'/delay').getValue();
    var oBaseConditionNode = Property.getNode(pathToDescription + '/conditions');
    if (oBaseConditionNode != null)
    {
        var oEnabledNode = oBaseConditionNode.getChild('enabled');
        if (oEnabledNode != null) {
            if (oEnabledNode.getValue() == false) {
                return false;
            }
        }

        // all system states must match
        var oStateNode = oBaseConditionNode.getChild('states');
        var oSystemStates = Property.getNode('/usr/states');
        if (oStateNode != null && oSystemStates) {
            var oStateArrayActual = oSystemStates.getChildren();
            var oStateArrayCondition = oStateNode.getChildren();
            for (var iIndex=0; iIndex < oStateArrayCondition.length; iIndex++)        // check only for requested state, other ignored
            {
                var fFound = false;
                for (var jIndex=0; jIndex < oStateArrayActual.length; jIndex++) {
                	
                    var testStateName = oStateArrayActual[jIndex].getChild('name');
                    var testStateValue = oStateArrayActual[jIndex].getChild('value');
                    if (testStateName ==null) {
                    	lInfo.logln('Null = ' + oStateArrayActual[jIndex].getPath());
                    } else {
	                    if (oStateArrayCondition[iIndex].getName() == testStateName.getValue()) { // search for a requested state
	                        fFound = true;                                                 // state found ...
	                        if (oStateArrayCondition[iIndex].getValue() != testStateValue.getValue()) {
	                            return false;
	                        }
	                        break;
	                    }
                    }
                }
                if (oStateArrayCondition[iIndex].getValue() == true) {                 // state was requested as active
                    if (fFound == false) {                                             // but not found -> condition failed  
                        return false;
                    }
                }
            }
        }

        // all addon-states must match

        
        // at least one of the zone states must match
        var oZoneNode = oBaseConditionNode.getChild('zone-states');
        if (oZoneNode != null) {
            var fMatch = false;
            var oStateArrayActual = oZoneNode.getChildren();
            for (var iIndex = 0; iIndex < oStateArrayActual.length; iIndex ++) {
                var testZoneId = oStateArrayActual[iIndex].getChild('zone').getValue();
                var testGroupId = oStateArrayActual[iIndex].getChild('group').getValue();
                var testSceneId = oStateArrayActual[iIndex].getChild('scene').getValue();

                var groupNode = Property.getNode('/apartment/zones/zone' +
                                    testZoneId + '/groups/group' + testGroupId);

                if (groupNode && (groupNode.getChild('lastCalledScene').getValue() == testSceneId)) {
                    fMatch = true;
                    break;
                }
            }
            if (!fMatch) {
                return false;
            }
        }

        var oWeekdayNode = oBaseConditionNode.getChild('weekdays');
        if (oWeekdayNode != null) {
            var sWeekdayString = oWeekdayNode.getValue();
            if (sWeekdayString != null) {
                var oNow = new Date();
                var oWeekDayArray = sWeekdayString.split(",");
                var fFound = false;
                for (var iIndex = 0; iIndex < oWeekDayArray.length; iIndex++)
                    if (parseInt(oWeekDayArray[iIndex]) == oNow.getDay()) {
                        fFound = true;
                        break;
                    }
                if (fFound == false) {
                    return false;
                }
            }
        }

        var oTimeStartNode = oBaseConditionNode.getChild('time-start');
        if (oTimeStartNode != null) {
            var sTime = oTimeStartNode.getValue();
            var oTimeTemp = sTime.split(':');
            if (oTimeTemp.length == 3) {
                var secondsSinceMidnightCondition = (parseInt(oTimeTemp[0]) * 3600) + (parseInt(oTimeTemp[1]) * 60) +  parseInt(oTimeTemp[0]) + delay;
                var oNow = new Date();
                var secondsSinceMidnightNow = (oNow.getHours() * 3600) + (oNow.getMinutes() * 60) + (oNow.getSeconds());
                if (! (secondsSinceMidnightCondition <= secondsSinceMidnightNow)) {
                    return false;
                }
            }
        }

        var oTimeEndNode = oBaseConditionNode.getChild('time-end');
        if (oTimeEndNode != null) {
            var sTime = oTimeEndNode.getValue();
            var oTimeTemp = sTime.split(':');
            if (oTimeTemp.length == 3) {
                var secondsSinceMidnightCondition = (parseInt(oTimeTemp[0]) * 3600) + (parseInt(oTimeTemp[1]) * 60) +  parseInt(oTimeTemp[0]);
                var oNow = new Date();
                var secondsSinceMidnightNow = (oNow.getHours() * 3600) + (oNow.getMinutes() * 60) + (oNow.getSeconds());
                if (! (secondsSinceMidnightNow <= secondsSinceMidnightCondition)) {
                    return false;
                }
            }
        }
    }
    return true;
}


function timeStamp() {
	var oDate = new Date();
	return oDate.getDate() + "." + (oDate.getMonth() + 1) + "."
			+ oDate.getFullYear() + " " + oDate.getHours() + ":"
			+ addLeadingZeroes(oDate.getMinutes(),2);
}

function replaceTags(sText)
{
    sText=unescape(sText);	
	sText=sText.replace("%timestamp%",timeStamp());
	return sText;
}

function sendMail(baseNode)
{
	lInfo.logln("event-checker: sending + " + baseNode.getPath());
	if (baseNode.getChild('message')==null)
		return;
	var mailParamNodes = baseNode.getChild('message');
	
	if (mailParamNodes.getChild('messageType')!=null) {
		if (mailParamNodes.getChild('messageType').getValue()=='email') {
			var parameter={};
			var prop = mailParamNodes.getChild('receiver');
			var to=prop.getValue();
			prop = mailParamNodes.getChild('messageBody');
			var body=replaceTags(prop.getValue());
			prop = mailParamNodes.getChild('subject');
			var subject=replaceTags(prop.getValue());
			lInfo.logln("Email-Mailer: sende Email an: " + to + " Subject: " +subject + " Body: "+ body);
			var evt = new Event("event-checker-email",{'to':to,'body':body,'subject':subject,'from':'dSS-Benachrichtigung'});			
			evt.raise();
		} 
	}
}

function makeAction(oThreshold,fTesting) {
	if (fTesting!=null)		
		(new Event('action_execute',{path:oThreshold.getPath(),ignoreConditions:'ignoreConditions'})).raise();
	else
		(new Event('action_execute',{path:oThreshold.getPath()})).raise();
	sendMail(oThreshold);	
}

function checkSingle(oThreshold,lastActionTime,lastActionAKM,iNow) {
 
	if (!checkCondition(oThreshold.getPath())) {
		lInfo.logln('Condition did not match for ' + oThreshold.getPath());
		Property.setProperty(oThreshold.getPath() + '/active', false);
		return;
	}
			
	var fActive=false;
	if (oThreshold.getChild('active')!=null)
		fActive=oThreshold.getChild('active').getValue();
	var iThreshold=oThreshold.getChild('delay').getValue();
	
	var fObserveShouldFireScene=-1; //-1 not measured, 0 : is ok, 1: should trigger
	var fObserveShouldFireAkm=-1;
	var fObserveShouldFireSensor=-1;
	if (lastActionTime!=-1)
		if (oThreshold.getChild('trigger/scene').getValue()) {
			lInfo.logln('Checking Scenevalue with lastValue+delay: ' + (lastActionTime+iThreshold) + ' against ' + iNow);
			if ((lastActionTime+iThreshold)<iNow) {
				fObserveShouldFireScene=1;
			} else
				fObserveShouldFireScene=0;
		}

	if (lastActionAKM!=-1) // if there is a motion, lastActionAkm =0
		if (oThreshold.getChild('trigger/akm').getValue()) {
			lInfo.logln('Checking AKM with lastValue+delay: ' + (lastActionAKM+iThreshold) + ' against ' + iNow);
			if (lastActionAKM==0) {
				fObserveShouldFireAkm=0;
			} else if ((lastActionAKM+iThreshold)<iNow) {
				fObserveShouldFireAkm=1;
			} else
				fObserveShouldFireAkm=0;
		}


	if (oThreshold.getChild('trigger/deviceSensor')!=null)
		if (oThreshold.getChild('trigger/deviceSensor').getChildren()!=null) {
			var oArray=oThreshold.getChild('trigger/deviceSensor').getChildren();
			for (var iIndex=0;iIndex<oArray.length;iIndex++) {
				var sString=oArray[iIndex].getValue();
				if (Property.getNode('lastActionTimeSensor/' + sString)!=null) {
					var lastSensorValue=Property.getNode('lastActionTimeSensor/' + sString).getValue();
					lInfo.logln('Checking ' + lastSensorValue + ' with lastValue+delay: ' + (lastSensorValue+iThreshold) + ' against ' + iNow);
					if (fObserveShouldFireSensor!=0)
						if ((lastSensorValue+iThreshold)<iNow) {
							fObserveShouldFireSensor=1;
						} else
							fObserveShouldFireSensor=0;
				}
			}
		}
	lInfo.logln('Scene Calls: ' + fObserveShouldFireScene + ' | AKM ' + fObserveShouldFireAkm + ' | Sensor ' + fObserveShouldFireSensor);
	
	if (fObserveShouldFireScene==-1) 
		if (fObserveShouldFireAkm==-1) 
			if (fObserveShouldFireSensor==-1) {
				lInfo.logln('-> nothing to do');
				Property.setProperty(oThreshold.getPath() + '/active', false);
				return;
			} 
	// since -1 for all conditions are filtered out now, it should trigger if value is -1 or 1, but never 0
	if (fObserveShouldFireScene!=0) 
		if (fObserveShouldFireAkm!=0) 
			if (fObserveShouldFireSensor!=0) {	// alarm
				lInfo.logln('-> should Alarm');
				if (!fActive) {
					lInfo.logln('Threshold reached: ' + oThreshold.getPath());
					makeAction(oThreshold)
				}
				Property.setProperty(oThreshold.getPath() + '/active', true);
				return;
			}
	lInfo.logln('-> anything ok');
	Property.setProperty(oThreshold.getPath() + '/active', false);	
}

function checkevent() {

	if (Property.getNode('thresholds')==null)
		return;

	if (Property.getNode('thresholds').getChildren()==null)
		return;
	
	var iNow=Math.floor((new Date().getTime())/1000);

	var lastActionTimeScene=-1;
	var lastActionTimeAKM=-1;
	if (Property.getNode('lastActionTimeScene')!=null)
		lastActionTimeScene=Property.getNode('lastActionTimeScene').getValue();
	if (Property.getNode('lastActionTimeAKM')!=null)
		lastActionTimeAKM=Property.getNode('lastActionTimeAKM').getValue();
	
	var iNow=Math.floor((new Date().getTime())/1000);
	lInfo.logln('last actionTime scene ' + lastActionTimeScene + ' -> ' + iNow);
	lInfo.logln('last actionTime akm ' + lastActionTimeAKM + ' -> ' + iNow);
	var ThresholdArray=Property.getNode('thresholds').getChildren();
	for (var iIndex=0;iIndex<ThresholdArray.length;iIndex++) {
		try {
			checkSingle(ThresholdArray[iIndex],lastActionTimeScene,lastActionTimeAKM,iNow);
			
		} catch (e) {
			lWarn.logln(e);
		}
	}
	
}

if (raisedEvent.name=='event-checker') {
	if (Property.getProperty('active')!=false) 
		if (raisedEvent.parameter.actions=='check') {
			lInfo.logln('make a check');
			checkevent();
			lInfo.logln('did check');
		}
	if (raisedEvent.parameter.actions=='test') {
		makeAction(Property.getNode('thresholds/' + raisedEvent.parameter.id),true);		
	}
}